Package ghidra.framework.plugintool

# Class PluginConfigurationModel

java.lang.Object
ghidra.framework.plugintool.PluginConfigurationModel

public class PluginConfigurationModel extends Object

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PluginConfigurationModel(PluginInstaller pluginInstaller, PluginPackagingProvider pluginPackagingProvider)`
  `PluginConfigurationModel(PluginTool tool)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addPlugin(PluginDescription pluginDescription)`
  `void`
  `addSupportedPlugins(PluginPackage pluginPackage)`
  `List<PluginDescription>`
  `getAllPluginDescriptions()`
  `List<PluginDescription>`
  `getDependencies(PluginDescription pd)`
  Return the descriptions of the plugins that are dependent on some service that the plugin corresponding to the given PluginDescription provides.
  `PluginPackageState`
  `getPackageState(PluginPackage pluginPackage)`
  `List<PluginDescription>`
  `getPluginDescriptions(PluginPackage pluginPackage)`
  `List<PluginPackage>`
  `getPluginPackages()`
  `boolean`
  `hasDependencies(PluginDescription pluginDependency)`
  Return whether the plugin corresponding to the given PluginDescription has other plugins depending on a service it provides.
  `boolean`
  `hasOnlyUnstablePlugins(PluginPackage pluginPackage)`
  `boolean`
  `isLoaded(PluginDescription pluginDescription)`
  `void`
  `removeAllPlugins(PluginPackage pluginPackage)`
  `void`
  `removePlugin(PluginDescription pluginDescription)`
  `void`
  `setChangeCallback(Callback listener)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PluginConfigurationModel

    public PluginConfigurationModel(PluginTool tool)

  - ### PluginConfigurationModel

    public PluginConfigurationModel(PluginInstaller pluginInstaller, PluginPackagingProvider pluginPackagingProvider)

- ## Method Details

  - ### setChangeCallback

    public void setChangeCallback(Callback listener)

  - ### getPluginPackages

    public List<PluginPackage> getPluginPackages()

  - ### getPluginDescriptions

    public List<PluginDescription> getPluginDescriptions(PluginPackage pluginPackage)

  - ### isLoaded

    public boolean isLoaded(PluginDescription pluginDescription)

  - ### getPackageState

    public PluginPackageState getPackageState(PluginPackage pluginPackage)

  - ### addPlugin

    public void addPlugin(PluginDescription pluginDescription)

  - ### removeAllPlugins

    public void removeAllPlugins(PluginPackage pluginPackage)

  - ### addSupportedPlugins

    public void addSupportedPlugins(PluginPackage pluginPackage)

  - ### hasOnlyUnstablePlugins

    public boolean hasOnlyUnstablePlugins(PluginPackage pluginPackage)

  - ### removePlugin

    public void removePlugin(PluginDescription pluginDescription)

  - ### hasDependencies

    public boolean hasDependencies(PluginDescription pluginDependency)
    Return whether the plugin corresponding to the given PluginDescription has other plugins depending on a service it provides.
    Parameters:
      `pluginDependency` - PluginDescription of the plugin
    Returns:
      true if the plugin corresponding to the given PluginDescription has at least one plugin depending on a service it provides

  - ### getDependencies

    public List<PluginDescription> getDependencies(PluginDescription pd)
    Return the descriptions of the plugins that are dependent on some service that the plugin corresponding to the given PluginDescription provides.
    Parameters:
      `pd` - PluginDescription of the plugin
    Returns:
      the descriptions

  - ### getAllPluginDescriptions

    public List<PluginDescription> getAllPluginDescriptions()